# Integrations

### Drop-in MySQL Replacement

Dolt is the world's first version controlled SQL database. Dolt is designed to be a drop-in replacement for MySQL. All the tools you use with MySQL work the same way with Dolt but with Dolt's added version control features. Below is the list of ORMs and tools we have integrated with Dolt and links to the getting started guides.

Let us know what else you'd like to see tested by sending us [email](mailto:interest@dolthub.com) or come by our [Discord](https://discord.gg/gqr7K4VNKe).

### Connector Libraries and APIs

| Connector                                                                | Language | Blog                                                                                 | Sample Code                                                    |
| ------------------------------------------------------------------------ | -------- | ------------------------------------------------------------------------------------ | -------------------------------------------------------------- |
| [JDBC](https://docs.oracle.com/javase/8/docs/technotes/guides/jdbc/)     | Java     | [Blog](https://www.dolthub.com/blog/2024-10-11-dolt-with-jdbc/)                      | [Code](https://github.com/dolthub/dolt-jdbc-sample)            |
| [Perl DBI](https://dev.mysql.com/doc/refman/8.4/en/apis-perl.html)       | Perl     | [Blog](https://www.dolthub.com/blog/2024-11-29-dolt-with-perl/)                      | [Code](https://github.com/dolthub/dolt-perl-sample)            |
| [MySQL Connector/Python](https://dev.mysql.com/doc/connector-python/en/) | Python   | [Blog](https://www.dolthub.com/blog/2024-11-01-dolt-with-mysql-connector-in-python/) | [Code](https://github.com/dolthub/dolt-mysql-connector-python) |
| [sqlx (and database/sql)](https://github.com/jmoiron/sqlx)               | Golang   | [Blog](https://www.dolthub.com/blog/2025-01-24-go-sql-with-dolt/)                    | [Code](https://github.com/dolthub/dolt-go-sqlx-sample)         |

### Frameworks/ORMs

| ORM                                                                                       | Language   | Blog                                                                           | Sample Code                                                                  |
| ----------------------------------------------------------------------------------------- | ---------- | ------------------------------------------------------------------------------ | ---------------------------------------------------------------------------- |
| [ASP.NET Core](https://learn.microsoft.com/en-us/aspnet/core/introduction-to-aspnet-core) | C#         | [Blog](https://www.dolthub.com/blog/2024-02-28-works-with-dolt-dotnet-webapp/) | [Code](https://github.com/dolthub/dolt-dotnet-webapp-sample)                 |
| [Diesel](https://diesel.rs/)                                                              | Rust       | [Blog](https://www.dolthub.com/blog/2024-08-30-dolt-diesel-getting-started/)   | [Code](https://github.com/dolthub/dolt-diesel-getting-started)               |
| [Django](https://www.djangoproject.com/)                                                  | Python     | [Blog](https://www.dolthub.com/blog/2024-01-31-dolt-django/)                   | [Code](https://github.com/dolthub/dolt_django)                               |
| [Ecto](https://hexdocs.pm/ecto/Ecto.html)                                                 | Elixir     | [Blog](https://www.dolthub.com/blog/2021-07-16-ecto-dolt/)                     | [Code](https://github.com/VinaiRachakonda/Ecto-Dolt-Sample)                  |
| [EF Core](https://learn.microsoft.com/en-us/ef/core/)                                     | C#         | [Blog](https://www.dolthub.com/blog/2023-12-04-works-with-dolt-efcore/)        | [Code](https://github.com/dolthub/efcore-sample)                             |
| [Flutter](https://flutter.dev/)                                                           | Dart       | [Blog](https://www.dolthub.com/blog/2024-09-20-flutter-and-dolt/)              | [Code](https://github.com/dolthub/dolt-flutter-example)                      |
| [GORM](https://gorm.io/docs/)                                                             | Golang     | [Blog](https://www.dolthub.com/blog/2024-03-15-gorm-with-dolt)                 | [Code](https://github.com/dolthub/gorm-demo)                                 |
| [Hibernate](https://hibernate.org/)                                                       | Java       | [Blog](https://www.dolthub.com/blog/2023-11-13-dolt-on-hibernate/)             | [Code](https://github.com/dolthub/hibernate-sample)                          |
| [Knex.js](https://knexjs.org/)                                                            | Javascript | [Blog](https://www.dolthub.com/blog/2023-09-27-dolt-and-knexjs/)               | [Code](https://github.com/dolthub/dolt-knexjs-example)                       |
| [Laravel](https://laravel.com/)                                                           | PHP        | [Blog](https://www.dolthub.com/blog/2024-01-08-dolt-laravel/)                  | [Code](https://github.com/dolthub/chirper)                                   |
| [Pandas DataFrames](https://pandas.pydata.org/docs/reference/api/pandas.DataFrame.html)   | Python     | [Blog](https://www.dolthub.com/blog/2024-06-07-dolt-pandas-dataframes/)        | [Code](https://github.com/dolthub/dolt-pandas-dataframes)                    |
| [Ruby on Rails](https://rubyonrails.org/)                                                 | Ruby       | [Blog](https://www.dolthub.com/blog/2024-02-09-dolt-ruby-on-rails/)            | [Code](https://github.com/dolthub/dolt_rails)                                |
| [SQLAlchemy](https://www.sqlalchemy.org/)                                                 | Python     | [Blog](https://www.dolthub.com/blog/2023-07-12-sql-alchemy-getting-started/)   | [Code](https://github.com/timsehn/dolt-sqlalchemy-getting-started/tree/main) |
| [Shiny](https://shiny.posit.co/)                                                          | R          | [Blog](https://www.dolthub.com/blog/2024-04-26-dolt-r-shiny/)                  | [Code](https://github.com/dolthub/dolt_shiny)                                |
| [Prisma](https://www.prisma.io/)                                                          | TypeScript | [Blog](https://www.dolthub.com/blog/2024-06-28-dolt-and-prisma/)               | [Code](https://github.com/dolthub/dolt-prisma-example)                       |
| [FastAPI](https://fastapi.tiangolo.com/)                                                  | Python     | [Blog](https://www.dolthub.com/blog/2025-11-06-fastapi-works-with-dolt/)       | [Code](https://github.com/eric-richardson1/dolt-lists)                       |

### Tools

| Tool                                                                                       | Blog                                                                                      |
| ------------------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------- |
| [Apache Superset](https://superset.apache.org/)                                            | [Blog](https://www.dolthub.com/blog/2023-01-27-dolt-superset/)                            |
| [Datadog](https://www.datadoghq.com/)                                                      | [Blog](https://www.dolthub.com/blog/2024-05-17-dolt-datadog-dashboards/)                  |
| [Debezium](https://debezium.io/)                                                           | [Blog](https://www.dolthub.com/blog/2024-07-19-debezium-works-with-dolt/)                 |
| [Excel](https://www.microsoft.com/en-us/microsoft-365/excel)                               | [Blog](https://www.dolthub.com/blog/2023-11-24-dolt-excel)                                |
| [Google Sheets](https://www.google.com/sheets/about/#overview)                             | [Blog](https://www.dolthub.com/blog/2023-09-15-dolt-google-sheets/)                       |
| [Looker Studio](https://lookerstudio.google.com/)                                          | [Blog](https://www.dolthub.com/blog/2023-02-13-dolt-looker/)                              |
| [MediaWiki](https://www.mediawiki.org/wiki/MediaWiki)                                      | [Blog](https://www.dolthub.com/blog/2024-04-05-dolt-mediawiki-wikipedia/)                 |
| [Metabase](https://github.com/metabase/metabase)                                           | [Blog](https://www.dolthub.com/blog/2024-01-24-dolt-metabase/)                            |
| [Python MySQL Replication](https://github.com/julien-duponchelle/python-mysql-replication) | [Blog](https://www.dolthub.com/blog/2024-08-08-python-mysql-replication-works-with-dolt/) |
| [R Studio](https://posit.co/download/rstudio-desktop/)                                     | [Blog](https://www.dolthub.com/blog/2022-02-14-dolt-and-r/)                               |
| [Retool](https://retool.com/)                                                              | [Blog](https://www.dolthub.com/blog/2023-01-03-superpower-retool-with-dolt/)              |
| [WordPress](https://wordpress.com/)                                                        | [Blog](https://www.dolthub.com/blog/2023-08-04-wordpress-on-dolt/)                        |
| [XCA](https://hohnstaedt.de/xca/)                                                          | [Blog](https://www.dolthub.com/blog/2023-08-21-xca-on-dolt/)                              |

### App Builders

| App Builder                        | Blog                                                                       |
| ---------------------------------- | -------------------------------------------------------------------------- |
| [Replit](https://replit.com/)      | [Blog](https://www.dolthub.com/blog/2025-10-15-replit-works-with-dolt/)    |
| [Vercel v0](https://vercel.com/v0) | [Blog](https://www.dolthub.com/blog/2025-10-01-vercel-v0-works-with-dolt/) |
| [Lovable](https://lovable.dev/)    | [Blog](https://www.dolthub.com/blog/2025-10-28-lovable-works-with-dolt/)   |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dolthub.com/guides/dolt-tested-apps.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
